<?php
function adsl_awp($houtp, $rdata) {
  return preg_replace_callback('/.*?\x0a\x00[^\x20\x09].*?(?=\x0a\x00[^\x20\x09])/s', function($matches) use ($houtp) {
    if(trim($matches[0]) == '') return '';
    $txa = trim(@iconv('UTF-16LE','UTF-8//IGNORE',$matches[0]));
    if($txa == '') return '';
    $txa = str_replace(["\r","\t"], ['',' '], $txa);
    $txa = preg_replace('/\[[\/]?(!trs|com|trn|\*|lang[^\[\]\\\\]*)\]/', ' ', $txa);
    $txa = preg_replace('/\[url\][^\[\]]*\[\/url\]/', ' ', $txa);
    $txa = preg_replace('/\[s\][^\[\]]*\[\/s\]/', ' ', $txa);
    $txa = preg_replace('/\[\'\]([^\[\]]*)\[\/\'\]/', '$1'."\x301", $txa);
    $txa = preg_replace('/\[m\d\]\[\/m\]/', '', $txa);
    $txa = preg_replace('/\[\/m\][ ]*\n/', '[/m]', $txa);
    $txa = preg_replace('/\n[ ]+\n/', "\n\n", $txa);
    $txa = preg_replace('/[\n]{2,}/', "\n", $txa);
    $txa = preg_replace('/[ ]{2,}/', ' ', $txa);
    $txa = trim($txa);
    if($txa == '') return '';
    fwrite($houtp, "\n\n".$txa);
    return '';
  }, $rdata);
}

function adapter_dsl($fninpar, $fnoutp) {
  $flinp = true;
  foreach ($fninpar as $fninp) $flinp = $flinp && is_rf($fninp);
  if(!$flinp && !is_rf($fnoutp)) return false;
  if(is_rf($fnoutp)) return true;

  $houtp = fopen($fnoutp, 'a');
  fwrite($houtp, " ");
  foreach ($fninpar as $fninp) {
    $finpsz = filesize($fninp) - 2;
    $hinprd = fopen($fninp, 'r');
    $xsg = fread($hinprd, 2);
    $frwlen = 102400;
    if($finpsz < $frwlen) $frwlen = $finpsz;

    $xpd = preg_replace_callback('/(^|\x0a\x00)\x23\x00.*?(?=\x0a\x00)/', function($matches) {
      return '';
    }, fread($hinprd, $frwlen));
    $finpsz -= $frwlen;

    for( ; ; ) {
      if($finpsz > $frwlen) {
        $xpd = adsl_awp($houtp, $xpd.fread($hinprd, $frwlen));
        $finpsz -= $frwlen;
      } else {
        $xpd = adsl_awp($houtp, $xpd.fread($hinprd, $finpsz));
        break;
      }
    }
    fclose($hinprd);
  }
  fclose($houtp);
  return true;
}

?>